/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static GC gc;
static XImage *image;
static Dimension width, height;
static Colormap colormap;
static XColor colors[7];
/* ̾Ѱ */
static char *colornames[] = {
    "red", "orange", "yellow", "green", "light sea green", "blue", "violet"
};

/* ٥Ƚؿ (Хå) */
static void ExposeCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    /* ᡼򥦥ɥ˥ԡ */
    XPutImage(XtDisplay(w), XtWindow(w), gc, image, 0, 0, 0, 0, width, height);
}

/* (2) ܥ󤬲줿Ȥ˸ƤӽФ */
static void InputCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmDrawingAreaCallbackStruct *cb = (XmDrawingAreaCallbackStruct *)call_data;
    Widget label = (Widget)client_data;
    XImage *point;
    unsigned long pixel;
    XColor xcolor;
    char buff[BUFSIZ];
    XmString string;

    /* (3) ޥΥܥ󤬲줿Ȥ򰷤 */
    if (cb->event->type != ButtonPress)
        return;

    /* (4) ɥƤ򥤥᡼Ȥ (줿ʬ) */
    point = XGetImage(XtDisplay(w), XtWindow(w), cb->event->xbutton.x,
                      cb->event->xbutton.y, 1, 1, AllPlanes, ZPixmap);
    /* (5) ᡼ԥͤФ */
    pixel = XGetPixel(point, 0, 0);

    /* (6) ԥͤ鿧γǤͤ */
    xcolor.pixel = pixel;
    XQueryColor(XtDisplay(w), colormap, &xcolor);

    /* (7) ƿǤͤ٥ɽ */
    sprintf(buff, "RGB: %x, %x, %x",  xcolor.red, xcolor.green, xcolor.blue);
    string = XmStringCreateLocalized(buff);
    XtVaSetValues(label, XmNlabelString, string, NULL);
    XmStringFree(string);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, canvas, label;
    Arg al[20];
    int ac;
    int i, j, k;
    XColor exact;
    Visual *visual;
    int depth;
    int x, y;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    /* Xġ륭åȤ (ǥץ쥤򥪡ץ) */
    toplevel = XtAppInitialize(&app_context, "Getimage", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    /* åȤƥޥ͡ */
    canvas = XmCreateDrawingArea(panel, "canvas", al, ac);
    XtManageChild(canvas);
    /* ٥Ƚؿ (Хå) Ͽ */
    XtAddCallback(canvas, XmNexposeCallback, ExposeCB, NULL);

    /* ͤɽ٥ */
    ac = 0;
    label = XmCreateLabel(panel, "label", al, ac);
    XtManageChild(label);

    /* (1) ɥꥢǥܥ󤬲줿ȤΥХåϿ */
    XtAddCallback(canvas, XmNinputCallback, InputCB, label);

    /* ǥեȤΥ顼ޥåפ */
    colormap = DefaultColormapOfScreen(XtScreen(canvas));

    /* ̾ǿդ */
    for (i = 0; i < 7; i++) {
        if (XAllocNamedColor(XtDisplay(canvas), colormap,
                             colornames[i], &colors[i], &exact) == 0) {
            fprintf(stderr, "Cannot allocate color `%s'\n", colornames[i]);
            exit(1);
        }
    }

    XtRealizeWidget(toplevel); /* ǥɥ */

    /* եåƥȤ° */
    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);

    /* ɥꥢΥɥĴ٤ */
    XtVaGetValues(canvas, XmNvisual, &visual,
                          XmNdepth,  &depth,
                          XmNwidth,  &width,
                          XmNheight, &height, NULL);
    /* ᡼ */
    if ((image = XCreateImage(XtDisplay(canvas), visual, depth,
                              ZPixmap, 0, NULL, width, height,
                              BitmapPad(XtDisplay(canvas)), 0)) == NULL) {
        fprintf(stderr, "Cannot create image.\n");
        exit(1);
    }
    /* ᡼ǡդ */
    if ((image->data = malloc(image->bytes_per_line * height)) == NULL) {
        fprintf(stderr, "Cannot allocate memory for image.\n");
        exit(1);
    }
    /* ᡼ǡ */
    memset(image->data, 0, image->bytes_per_line * height);

    /* 7Ӥ򥤥᡼Ȥ */
    for (i = 0; i < 7; i++) {  /* 7Ĥοǥ롼 */
        for (j = 0; j < 140; j++) {  /* X  */
            x = j + 30;
            for (k = 0; k < 20; k++) {  /* Y  */
                y = k + i * 20 + 30;
                XPutPixel(image, x, y, colors[i].pixel);  /* ֤ */
            }
        }
    }

    XtAppMainLoop(app_context);
}
